{\rtf0\ansi{\fonttbl\f0\fmodern Courier;\f1\ftech Symbol;}
\paperw11640
\paperh8400
\margl120
\margr120
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 //\
//
\i 	
\b FILENAME
\b0 :	
\b\i0 eTContainerView.m\

\b0 //
\i 	
\b SUMMARY
\b0 :	
\b\i0 Interceptor object between eTDoc's splitView and agent.
\b0 \
//	
\b\i SUPERCLASS
\b0 :
\i0 	
\b Object:Responder:View:eTContainerView
\b0 \
//	
\b\i PROTOCOLS
\b0 :
\i0 	
\b None
\b0 \
//	
\b\i INTERFACE
\b0 :
\i0 	
\b None
\b0 \
//	
\b\i AUTHOR
\b0 :		
\b\i0 Rohit Khare
\b0 \
//	
\b\i COPYRIGHT
\b0 :	
\f1\i0 
\f0\b 1993,94 California Institure of Technology, eText Project\

\b0 //\
//	
\b\i Implementation Comments
\b0\i0 \
//		The new scrolling behavior is isolated in the splitView delegate call.\
//\
//	
\b\i HISTORY
\b0\i0 \
//	10/05/94:	
\b Created. Extracted from eTDocUI.
\b0 \
//\
//	
\b Imported Interfaces
\b0 \
//\
	#import "
\b eTContainerView.h
\b0 "\
\

\i @implementation eTContainerView\

\i0 \
//\
//	
\b "API"
\b0 \
//\

- 
\b attachAgent
\b0 :newAgent \{\
	
\b theAgent
\b0  = 
\b newAgent
\b0 ;\
	[theAgent 
\b getMinSize
\b0 :&
\b min
\b0 ];\
	[theAgent 
\b getMaxSize
\b0 :&
\b max
\b0 ];\
	
\b contentView
\b0  = [theAgent 
\b controlView
\b0 ];\
	[self 
\b addSubview
\b0 :
\b contentView
\b0 ];\
	return self;\
\}\
\
- 
\b docView
\b0  \{\
	return 
\b contentView
\b0 ;\}\
\
- 
\b drawSelf
\b0 :(const NXRect *)
\b rects
\b0  :(int)
\b rectCount
\b0  \{\
	NXRect	r; NXRect s;\
\
	[self 
\b getBounds
\b0 :&
\b r
\b0 ];\
	[
\b contentView
\b0  
\b getBounds
\b0 :&
\b s
\b0 ];\
	r.
\b origin
\b0 .
\b y
\b0  = 
-(
\b s
\b0 .
size.
\b height
\b0  - 
\b r
\b0 .
size.
\b height
\b0 );\
	[contentView 
\b moveTo
\b0 :r.
\b origin
\b0 .
\b x
\b0  :r.
\b origin
\b0 .
\b y
\b0 ];\
	[contentView 
\b sizeTo
\b0 :r.
\b size
\b0 .
\b width
\b0  :s.
\b size
\b0 .
\b height
\b0 ];\
	return self;\
\}\
\
//\
//	
\b NXSplitView Delegate
\b0 \
//\
- 
\b splitView
\b0 :sender \

\b 	getMinY
\b0 :(NXCoord *)
\b minY
\b0   \

\b 	   maxY
\b0 :(NXCoord *)
\b maxY
\b0 \

\b ofSubviewAt
\b0 :(int)
\b offset
\b0 ; 
\{\
	*
\b minY
\b0  = *
\b maxY
\b0  - 
\b max
\b0 .
\b height
\b0 ;\
	
//
\i  if ( *minY < 100.0 ) *minY = 100.0;
\i0 \
	*
\b maxY
\b0  
\b -=
\b0  min.
\b height
\b0 ;\
	return self;\
\}\
\
- 
\b getMinSize
\b0 :(NXSize *) 
\b sz
\b0  \{\
	*
\b sz
\b0  = 
\b min
\b0 ; return self;\}\
\

\i @end
}
