{\rtf0\ansi{\fonttbl\f0\fmodern Courier;\f1\ftech Symbol;\f2\fmodern Ohlfs;}
\margl40
\margr40
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 //\
//
\i 	
\b FILENAME
\b0 :	
\b\i0 eTDocInfoUI.h \

\b0 //
\i 	
\b SUMMARY
\b0 :	
\b\i0 Inspector/Controller for eText-based eTDocInfos
\b0 \
//	
\b\i SUPERCLASS
\b0 :
\i0 	
\b Object:eTDocInfoUI
\b0 \
//	
\b\i PROTOCOLS
\b0 :
\i0 	
\b <Inspectable>
\b0 \
//	
\b\i INTERFACE
\b0 :
\i0 	
\b eTDocInfoUI.nib
\b0 \
//	
\b\i AUTHOR
\b0 :		
\b\i0 Rohit Khare
\b0 \
//	
\b\i COPYRIGHT
\b0 :	
\f1\i0 
\f0\b 1993,94 California Institure of Technology, eText Project\

\b0 //\
//	
\b\i Description
\b0\i0 \
//		The controller has a "universal panel" for configuring the required\
//	fields of 
\i eTDocInfo
\i0  and a tagging panel for manipulating the fonts used\
//	to denote logical markup.\
//\
//	
\b\i HISTORY\

\b0\i0 //	10/04/94:	
\b Revamped for eText5; renamed eTDocInfoUI
\b0 \
//	05/23/94:	
\b TaggingPanel support added for HTML/LaTeX inversion\

\b0 //	01/15/94:	
\b Created for eText4.0. Borrows from DocInspector in eText3.0
\b0 \
//\
//	
\b Imported Interfaces
\b0 \
//\
	#import "
\b eTDocInfo.h
\b0 "\
\

\i @interface eTDocInfoUI:Object <Inspectable> 
\i0 \{\
//\
//	
\b Instance Variables
\b0 \
//\
	#define 	
\b PROP
\b0  			"
\b Properties
\b0 "\
	id 			
\b docInfoPanel
\b0 , 	
\i docInfoView
\i0 ;\
	#define 	
\b TAGS
\b0  			"
\b Tagging Fonts
\b0 "\
	id			
\b taggingPanel
\b0 , 	
\i taggingView
\i0 ;\
	#define 	
\b INFO
\b0  			"
\b Info
\b0 "\
	id			
\b infoPanel
\b0 , 		
\i infoView
\i0 ;\
	
\b TextField
\b0  	*
\b title
\b0 ,*
\b keywords
\b0 ,*
\b author
\b0 , *
\b parent
\b0 ,*
\b peers
\b0 ,*
\b docIDField
\b0 ,*
\b dateField
\b0 ;\
	
\b Text
\b0  		*
\b comments
\b0 ;\
	
\b Button
\b0 		*
\b trailerSw
\b0 ;\
	
\b eTDocInfo
\b0  	*
\b theDocInfo
\b0 ;\
	
\b eTLinkWell
\b0 	*
\b parent
\b0 Well, *
\b peers
\b0 Well;\
	
\b FontWell
\b0  	*
\b heading1
\b0 Well, *
\b heading2
\b0 Well, *
\b heading3
\b0 Well, *
\b heading4
\b0 Well,\
				*
\b heading5
\b0 Well, *
\b heading6
\b0 Well, *
\b quotation
\b0 Well, *
\b body
\b0 Well;\
	\}\
\
//\
// 	
\b Class Management
\b0 \
//\
	+ 
\b new
\b0 ;\
	- 
\b free
\b0 ;\
	- 
\b init
\b0 ;\
	- 
\b setDocInfo
\b0 :newDocInfo;\
\
//\
// 	
\b UI Callbacks
\b0 \
//\
	- 
\b accept
\b0 :sender;					// 
\i From eTLinkWells
\i0 \
	- 
\b textDidGetKeys
\b0 :sender 
\b isEmpty
\b0 :(BOOL)flag;\
	- 
\b textWillConvert
\b0 :sender 
\b fromFont
\b0 :from 
\b toFont
\b0 :to;\
	- 
\b touch
\b0 :sender; 					// 
\i The FormCell action: method
\i0 \
	- 
\b touch
\b0 ;\
\

\i @end\
\

\i0 //\
//	
\b Text-specific Extensions
\b0 \
//\

\i @interface eTDocInfoUI(eText)\

\i0 //\
//	
\b Tagging Fonts
\b0 \
//\
	- 
\b setDefaultTags
\b0 :sender;\
	- 
\b getDefaultTags
\b0 :sender;\
	\
	- 
\b setHeading1
\b0 :sender;\
	- (
\b Font
\b0  *)
\b heading1
\b0 ;\
	\
	- 
\b setHeading2
\b0 :sender;\
	- (
\b Font
\b0  *)
\b heading2
\b0 ;\
	\
	- 
\b setHeading3
\b0 :sender;\
	- (
\b Font
\b0  *)
\b heading3
\b0 ;\
	\
	- 
\b setHeading4
\b0 :sender;\
	- (
\b Font
\b0  *)
\b heading4
\b0 ;\
	\
	- 
\b setHeading5
\b0 :sender;\
	- (
\b Font
\b0  *)
\b heading5
\b0 ;\
	\
	- 
\b setHeading6
\b0 :sender;\
	- (
\b Font
\b0  *)
\b heading6
\b0 ;\
	\
	- 
\b setQuotation
\b0 :sender;\
	- (
\b Font
\b0  *)
\b quotation
\b0 ;\
	\
	- 
\b setBody
\b0 :sender;\
	- (
\b Font
\b0  *)
\b body
\b0 ;
\i \
@end
}
