{\rtf0\ansi{\fonttbl\f0\fmodern Courier;\f1\ftech Symbol;\f3\fmodern Ohlfs;}
\margl40
\margr40
{\colortbl;\red0\green0\blue0;}
\pard\tx520\tx1060\tx1600\tx2120\tx2660\tx3200\tx3720\tx4260\tx4800\tx5320\f0\b0\i0\ulnone\fs24\fc0\cf0 //\
//
\i 	
\b FILENAME
\b0 :	
\b\i0 eTDocUI.h \

\b0 //
\i 	
\b SUMMARY
\b0 :	
\b\i0 Interface for the UI & Window management of eTDoc documents.
\b0 \
//	
\b\i SUPERCLASS
\b0 :
\i0 	
\b Object:eTDocUI
\b0 \
//	
\b\i PROTOCOLS
\b0 :
\i0 	
\b <DocNotification>, uses <Agent>
\b0 \
//	
\b\i INTERFACE
\b0 :
\i0 	
\b eTDocUI.nib
\b0 \
//	
\b\i AUTHOR
\b0 :		
\b\i0 Rohit Khare
\b0 \
//	
\b\i COPYRIGHT
\b0 :	
\f1\i0 
\f0\b 1993,94 California Institure of Technology, eText Project\

\b0 //\
//	
\b\i Description
\b0\i0 \
//		This is the document UI, and thus encapsulates NEXTSTEP-dependent\
//	behavior, especially interaction with the First Responder chain. It manages\
//	a document window, as designed in 
\i eTDoc.nib
\i0 .\
//		The eText5 version is cognizant of issues in managing multiple 
\i types
\i0  of\
//	documents; c.f. design discussions of 
\i eText
\i0  vs. 
\i eDraw
\i0  substrates.\
//		
\b\i Design Note
\b0\i0 : Ideally, no class except 
\i eTDoc
\i0  should talk to 
\i eTDocUI
\i0 ;\
//	but the window delegate's central role in message dispatch makes this\
//	difficult (and its accessibility within the drawing-loop).\
//\
//	
\b\i HISTORY
\b0\i0 \
//	10/05/94:	
\b Revamped for eText5.
\i \

\b0\i0 //	08/05/94:	
\b Removed ChangeManager, migrated to UndoManager. RK
\b0 \
//	05/13/94:	
\b Added support for etUIinfo, <DocNotification>
\b0 \
//	01/14/94:	
\b Revised extensively for eText4.0
\b0 \
//	08/20/93:	
\b Created.
\b0 \
//\
//	
\b Imported Interfaces
\b0 \
//\
	#import	"
\b eTextKernel.h
\b0 "\
	#import "
\b eTContainerView.h
\b0 "\
	\
	#define	
\b UIINFOFILE
\b0 		"
\b .etUInfo
\b0 "\
	#define	
\b UIINFOFILE2
\b0 		"
\b .etUIinfo
\b0 "\
\

\i @interface eTDocUI:Object <DocNotification> 
\i0 \{\
//\
//	
\b Instance Variables
\b0 \
//\
	
\b Window
\b0 		*
\b theWindow
\b0 ;\
	
\b ScrollView
\b0 	*
\b theScroller
\b0 ;\
	
\b NXSplitView
\b0 	*
\b theSplitview
\b0 ;\
	
\b View
\b0 		*
\b theContainer
\b0 ;\
	
\b PrintInfo
\b0 	*
\b printInfo
\b0 ;\
	
\b eText
\b0 		*
\b eTextObj
\b0 ;\
	
\b eTDoc
\b0 		*
\b etDoc
\b0 ;\
	
\b id
\b0 			
\b theAgent
\b0 ;\
	
\b int		
\b0  	
\b begin
\b0 , 
\b end
\b0 ;		//
\i rendezvous globals; see docWillWrite:
\i0 \
	\}\
\
//\
// 	
\b Class Management
\b0 \
//\
	- 
\b init
\b0 ;\
	- 
\b free
\b0 ;\
	- 
\b awakeFromNib
\b0 ;\
	- 
\b setDoc
\b0 :theDoc;\
\
//\
// 	
\b FirstResponder Document UI Callbacks
\b0 \
//\
	- 
\b undo
\b0 :sender;\
	- 
\b redo
\b0 :sender;\
	\
	- 
\b save
\b0 :sender;\
	- 
\b saveAs
\b0 :sender;\
	- 
\b saveTo
\b0 :sender;\
	- 
\b saveTo
\b0 :sender 
\b changePath
\b0 :(
\b BOOL
\b0 ) changeIt 
\b forceETFD
\b0 :(
\b BOOL
\b0 ) forceIt;\
	\
	- 
\b close
\b0 :sender;\
	- 
\b close
\b0 :sender 
\b allowCancel
\b0 :(
\b BOOL
\b0 )cancellable;\
	\
	- 
\b revert
\b0 :sender;\
	- 
\b print
\b0 :sender;\
	\
	- (
\b BOOL
\b0 )
\b validateCommand
\b0 :MenuCell;\
\
//\
// 	
\b Window Management & Callbacks
\b0 \
//\
	- 
\b touch
\b0 ;\
	- (
\b BOOL
\b0 ) 
\b needsSaving
\b0 ;\
\
	- 
\b windowWillClose
\b0 :sender;\
	- 
\b windowDidBecomeMain
\b0 :sender;\
	- 
\b windowDidResignMain
\b0 :sender;\

\fc1\cf1 	- 
\b windowWillMiniaturize
\b0 :sender 
\b toMiniwindow
\b0 :counterpart;\

\fc0\cf0 \
//\
// 	
\b Public Accessors & API
\b0 \
//\
	- 
\b eTextObj
\b0 ;\
	- 
\b scroller
\b0 ;\
	- 
\b etDoc
\b0 ;\
	- 
\b window
\b0 ;\
	\
	- 
\b attachAgent
\b0 :newAgent;\
	- 
\b detachAgent
\b0 ;\
\

\i @end
}
